untyped

global function OnWeaponPrimaryAttack_shifter
global function MpAbilityShifterWeapon_Init
global function MpAbilityShifterWeapon_OnWeaponTossPrep
global function AbilityShifter_ApplyInProgressStimIfNeeded


#if SERVER

global function createindicator
global const phasemodversion = 1.72
const vector roofcheckheight = < 0,0,100 > //how far to check for a roof
global table<string, vector> playerorigpostable
global table<string, bool> playerrewindusedtable
global table<string , bool> playerongoingcounttable
global table<string, bool> startposonground
global table<string, bool> startpostouchedroof

#endif

const SHIFTER_WARMUP_TIME = 0.0
const SHIFTER_WARMUP_TIME_FAST = 0.0

const string PHASEEXIT_IMPACT_TABLE_PROJECTILE	= "default"
const string PHASEEXIT_IMPACT_TABLE_TRACE		= "superSpectre_groundSlam_impact"

struct
{
	int phaseExitExplodeImpactTable
} file;

void function MpAbilityShifterWeapon_Init()
{
	// "exp_rocket_archer"
	// "exp_xlarge"
	// "exp_arc_ball"

	file.phaseExitExplodeImpactTable = PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_PROJECTILE )
	PrecacheImpactEffectTable( PHASEEXIT_IMPACT_TABLE_TRACE )
}

void function MpAbilityShifterWeapon_OnWeaponTossPrep( entity weapon, WeaponTossPrepParams prepParams )
{
	entity weaponOwner = weapon.GetWeaponOwner()
	int pmLevel = GetPVEAbilityLevel( weapon )
	if ( (pmLevel >= 2) && IsValid( weaponOwner ) && weaponOwner.IsPhaseShifted() )
		weapon.SetScriptTime0( Time() )
	else
		weapon.SetScriptTime0( 0.0 )
}

int function GetPVEAbilityLevel( entity weapon )
{
	if ( weapon.HasMod( "pm2" ) )
		return 2
	if ( weapon.HasMod( "pm1" ) )
		return 1
	if ( weapon.HasMod( "pm0" ) )
		return 0

	return -1
}



/////////////////////////////////////////modified act func///////////////////////////////////////////////////
const float PMMOD_ENDLESS_STRENGTH = 0.8
var function OnWeaponPrimaryAttack_shifter( entity weapon, WeaponPrimaryAttackParams attackParams ){

	#if SERVER
	entity player = weapon.GetWeaponOwner()
	entity indicatorent




	if (weapon.GetWeaponPrimaryClipCount() == 400 ) { //first charge
		thread move (player , weapon)
		addplayerorigpos(player,player.GetOrigin())
		indicatorent = createindicator(getplayerorigpos(player))
		weapon.SetWeaponPrimaryClipCount(200)
	}
	else if(weapon.GetWeaponPrimaryClipCount() == 200 && GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) { //second charge
		thread moveback(player,getplayerorigpos(player))
		weapon.SetWeaponPrimaryClipCount(0)
		player.TouchGround()//allways allows a double jump after phasing back
	}

	thread cooldownmngmnt (weapon,indicatorent)

	#endif
	return 0

}

///////////////////////////////////keeping track of player origpos'/////////////////////////////////////
#if SERVER
void function addplayerorigpos(entity player,vector origpos) {
	string playername = player.GetPlayerName()
	playerorigpostable[playername] <- origpos

	startposonground[playername] <- false // DB: Initializing
	startpostouchedroof[playername] <- false

	//check if player is on ground or underneath ceiling
	if( player.IsOnGround() ){
		startposonground[playername] <- true
	}

	if( TraceLine( player.GetOrigin(), player.GetOrigin() + roofcheckheight, [ player ], TRACE_MASK_SHOT, TRACE_COLLISION_GROUP_NONE ).hitEnt != null && !player.IsOnGround() ){ // DB: If there's something blocked the line, we consider it as touched the roof
		startpostouchedroof[playername] <- true
	}
}

vector function getplayerorigpos(entity player){
	return playerorigpostable[player.GetPlayerName()]
}
#endif

//////////////////////////////////////////////////////////////////////////////////////////////////////

void function ApplyInProgressStimIfNeededThread( entity player )
{
	wait 0.5  // timed to kick in when the notify appears on player's screen

	if ( !IsAlive( player ) )
		return
	if ( !player.IsPhaseShifted() )
		return

	EndlessStimBegin( player, PMMOD_ENDLESS_STRENGTH )
}

void function AbilityShifter_ApplyInProgressStimIfNeeded( entity player )
{
	thread ApplyInProgressStimIfNeededThread( player )
}

void function DoPhaseExitExplosion( entity player, entity phaseWeapon )
{
#if CLIENT
	if ( !phaseWeapon.ShouldPredictProjectiles() )
		return
#endif //

	player.PhaseShiftCancel()

	vector origin = player.GetWorldSpaceCenter() + player.GetForwardVector() * 16.0

	DebugDrawLine( player.GetWorldSpaceCenter(), origin, 255, 0, 0, true, 5.0 )

	int damageType = (DF_RAGDOLL | DF_EXPLOSION | DF_ELECTRICAL)
	entity nade = phaseWeapon.FireWeaponGrenade( origin, <0,0,1>, <0,0,0>, 0.01, damageType, damageType, true, true, true )
	if ( !nade )
		return

	player.PhaseShiftBegin( 0, 1.0 )

	nade.SetImpactEffectTable( file.phaseExitExplodeImpactTable )
	nade.GrenadeExplode( <0,0,0> )

#if SERVER
	PlayImpactFXTable( player.GetOrigin(), player, PHASEEXIT_IMPACT_TABLE_TRACE, SF_ENVEXPLOSION_INCLUDE_ENTITIES )
#endif //
}

/////////////////////////////////////////custom functions///////////////////////////////////////////////////
#if SERVER

void function move (entity player, entity weapon) {

	float velmultiplier;

	if (GetCurrentPlaylistVarInt("#Boost_Strength",0) == 0) {velmultiplier = 1;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 1){velmultiplier = 1.5;}
	if(GetCurrentPlaylistVarInt("#Boost_Strength",0) == 2){velmultiplier = 2;}

	PhaseShift(player, 0, 0.3 )
	vector viewvector = player.GetViewVector() * 1000 * velmultiplier
	player.SetVelocity(viewvector)
}

void function moveback (entity player , vector origpos) {

	string playername = player.GetPlayerName()
	playerrewindusedtable[player.GetPlayerName()] <- true

	entity mover = CreateOwnedScriptMover (player)
	player.SetParent(mover)
	PhaseShift(player, 0, 0.55 )

	if( startposonground[playername] ){ //too close to ground
		mover.NonPhysicsMoveTo (<origpos.x,origpos.y,origpos.z + 30>, 0.5,0,0) //bit of added z height to prevent getting stuck ( DB: in ground )}
		//print("Phase Log:Original Postion was on Ground , added height.")
	}
	else if( startpostouchedroof[playername] ){ // to close to roof
		mover.NonPhysicsMoveTo (<origpos.x,origpos.y,origpos.z - 30>, 0.5,0,0) //DB: Bit of minused z height to prevent getting stuck in roof
		//print("Phase Log:Original Postion was close to roof , removed height.")
	}
	else{ // just fine
		mover.NonPhysicsMoveTo (origpos, 0.5,0,0) //DB: Normal rewind
		//print("Phase Log:Original Postion was in the air , did nothing.")
	}
	wait 0.55;
	player.SetVelocity(<0,0,0>)
	player.ClearParent()
	mover.Destroy()

	if( PlayerPosInSolid( player, player.GetOrigin() ) ) //just teloprt the player to a save spot , if the stuff above didnt work and they still end up clipping anyway
	{
		vector TargetPos = FindNearestSafePos( player, player.GetOrigin(), 1 )
		player.SetOrigin( TargetPos )
	}

}

void function cooldownmngmnt (entity weapon,entity indicatorent) {



	if (playerongoingcounttable[weapon.GetWeaponOwner().GetPlayerName()] == false) { //function gets called twice in ability "cycle" , prevents two timers from going at the same time

		string playername = weapon.GetWeaponOwner().GetPlayerName()

		weapon.EndSignal( "OnDestroy" ) //when the weapon gets destroyed the thread ends
		OnThreadEnd(	//when the thread is over this runs
			function(): ( playername )
			{
				playerongoingcounttable[playername] <- false
				playerrewindusedtable[playername] <- false
				startposonground[playername] <- false
				startpostouchedroof[playername] <- false
			}
		)

		try {
			playerongoingcounttable[weapon.GetWeaponOwner().GetPlayerName()] <- true


			//possible rewind window//
			if (GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) {
				int x = 0
				int deco_x = 5
				while (x < 5) {
					if (playerrewindusedtable[weapon.GetWeaponOwner().GetPlayerName()] == true) {break}
					SendHudMessage(weapon.GetWeaponOwner(),"Rewind Possible: "+string(deco_x),-1,0.65,255,255,255,1,0,1,0)
					x++
					deco_x = deco_x -1
					//print("phase window:"+x)
					wait 1;
				}
			}

			//needs to be 0ed in case the player didnt phase back
			deleteindicator(indicatorent)
			weapon.SetWeaponPrimaryClipCount(0)

			//cooldown//
			int cooldownint = GetCurrentPlaylistVarInt("#Boost_Cooldown", 5)
			wait cooldownint

			//reset\cleanup//
			weapon.SetWeaponPrimaryClipCount(400)
			SendHudMessage(weapon.GetWeaponOwner(),"Boost Ready!",-1,0.65,255,255,255,1,0,1,0) //player //text //x //y //r //g //b  /a  //fade-in s //lenght s //fade-out s


		} catch (exception){print("phase-cooldown-error: "+exception)}


	}
}

entity function createindicator (vector location) {

	if (GetCurrentPlaylistVarInt("#Enable_Phase_Rewind",1) == 1) {
		entity ind = CreateEntity( "prop_dynamic" )
		ind.SetValueForModelKey( $"models/fx/core_energy.mdl" )
		ind.SetOrigin( <location.x,location.y,location.z+50>)
		DispatchSpawn( ind )

		thread indicatortimeout(ind)

		return ind
	}

}

void function indicatortimeout(entity indicator) {
	wait 10
	try{indicator.Destroy()}
	catch(ex){/*print("Phase Error:"+ex)*/}
}

void function deleteindicator (entity indicator) {

	if (IsValid(indicator)) {
		indicator.Destroy()
	} else (print("Phase Error:"+"Deletion Object wasnt valid"))

}

vector function FindNearestSafePos(entity player, vector targetPos, int severity) //this uses recursion I think
{
    if(severity >= 300)
    {
        print("Phase error:could not find a save position for player")
       return < player.GetOrigin().x,player.GetOrigin().y,player.GetOrigin().z+1500 >
    }


	//check if adding/removing severity  from the x,y or z coords will stop the player from clipping
    if( !PlayerPosInSolid( player, < targetPos.x, targetPos.y+severity, targetPos.z > ) )
        return < targetPos.x, targetPos.y+severity, targetPos.z >

    if( !PlayerPosInSolid( player, < targetPos.x, targetPos.y-severity, targetPos.z > ) )
        return < targetPos.x, targetPos.y-severity, targetPos.z >

    if( !PlayerPosInSolid( player, < targetPos.x+severity, targetPos.y, targetPos.z > ) )
        return < targetPos.x+severity, targetPos.y, targetPos.z >

    if( !PlayerPosInSolid( player, < targetPos.x-severity, targetPos.y, targetPos.z > ) )
        return < targetPos.x-severity, targetPos.y, targetPos.z >

	if( !PlayerPosInSolid( player, < targetPos.x, targetPos.y, targetPos.z +severity> ) )
        return < targetPos.x, targetPos.y, targetPos.z +severity>

    if( !PlayerPosInSolid( player, < targetPos.x, targetPos.y, targetPos.z -severity > ) )
        return < targetPos.x, targetPos.y, targetPos.z -severity>


    return FindNearestSafePos( player, targetPos, severity+5 ) //severity goes up by 5 each time adding severity doesnt stop the player from clipping
}

bool function PlayerPosInSolid( entity player, vector targetPos ) //checks if a the player would be clipping if he were in targetpos
{
    int solidMask = TRACE_MASK_PLAYERSOLID
    vector mins
    vector maxs
    int collisionGroup = TRACE_COLLISION_GROUP_PLAYER
    array<entity> ignoreEnts = []
    ignoreEnts.append( player ) //in case we want to check player's current pos
    TraceResults result

    mins = player.GetPlayerMins()
    maxs = player.GetPlayerMaxs()
    result = TraceHull( targetPos, targetPos + Vector( 0, 0, 1), mins, maxs, ignoreEnts, solidMask, collisionGroup )
    if ( result.startSolid )
        return true

    return false

}


////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif











//note to self: FindNearestSafePos, PlayerPosInSolid and the ground/roof checking was done by VoyageDB#5167 on discord